"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/openai/openai.index.ts
var openai_index_exports = {};
__export(openai_index_exports, {
  OpenAIUtils: () => OpenAIUtils
});
module.exports = __toCommonJS(openai_index_exports);

// ../shared/src/ts.utils.ts
function never(neverCheck, value) {
  throw new Error(
    `Unexpected value, received: ${JSON.stringify(value ?? neverCheck, null, 2)}`
  );
}

// src/openai/openai.runner.ts
var import_zod_to_json_schema = __toESM(require("zod-to-json-schema"), 1);
var OpenAIUtils = class _OpenAIUtils {
  static models = {
    GPT_3_5_TURBO: "gpt-3.5-turbo",
    GPT_4: "gpt-4",
    GPT_4_TURBO: "gpt-4-turbo",
    GPT_4O: "gpt-4o",
    GPT_4O_MINI: "gpt-4o-mini"
  };
  static mapCompletionQuery(query) {
    const systemMessages = _OpenAIUtils.systemMessages(query.system);
    const messages = query.messages.map(_OpenAIUtils.mapMessage);
    return {
      // Todo: repair
      model: "query.model",
      max_tokens: query.maxTokens,
      temperature: query.temperature,
      messages: [...systemMessages, ...messages],
      tools: _OpenAIUtils.tools(query.toolsConfig),
      tool_choice: _OpenAIUtils.toolChoice(query.toolsConfig)
    };
  }
  static systemMessages(instructions) {
    if (!instructions) return [];
    return [
      {
        role: "system",
        content: instructions
      }
    ];
  }
  static tools(toolsConfig) {
    if (toolsConfig === void 0) return void 0;
    if (toolsConfig.type === "multi")
      return toolsConfig.tools.map(_OpenAIUtils.mapTool);
    if (toolsConfig.type === "single")
      return [_OpenAIUtils.mapTool(toolsConfig.tool)];
    never(toolsConfig);
  }
  static toolChoice(toolsConfig) {
    if (toolsConfig === void 0) return "none";
    if (toolsConfig.type === "single")
      return {
        type: "function",
        function: {
          name: toolsConfig.tool.name
        }
      };
    if (toolsConfig.requireToolUse) return "required";
    return "none";
  }
  static mapTool(functionCall) {
    const schema = (0, import_zod_to_json_schema.default)(functionCall.schema);
    delete schema.$schema;
    return {
      type: "function",
      function: {
        name: functionCall.name,
        description: functionCall.schema?.description,
        parameters: schema
      }
    };
  }
  static mapMessage(message) {
    if (message.role === "assistant")
      return message;
    if (message.role === "user")
      return {
        role: "user",
        content: message.content.map(_OpenAIUtils.mapMessageContent)
      };
    throw new Error("Unknown message role");
  }
  static mapMessageContent(messagePart) {
    if (messagePart.type === "text")
      return messagePart;
    if (messagePart.type === "image")
      return {
        type: "image_url",
        image_url: {
          url: messagePart.image.data
        }
      };
    throw new Error("Unknown message content type");
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  OpenAIUtils
});
//# sourceMappingURL=openai.index.cjs.map