import { ChatCompletionAssistantMessageParam, ChatCompletionUserMessageParam, ChatCompletionTool, ChatCompletionToolChoiceOption } from 'openai/resources/index';
import { L as Llm } from '../llm.types-C70OLa4M.cjs';
import 'zod';

type CompleteOpenAICompletion = Llm.Completion;
declare class OpenAIUtils {
    static readonly models: {
        GPT_3_5_TURBO: string;
        GPT_4: string;
        GPT_4_TURBO: string;
        GPT_4O: string;
        GPT_4O_MINI: string;
    };
    static mapCompletionQuery(this: void, query: CompleteOpenAICompletion): {
        model: "query.model";
        max_tokens: number;
        temperature: number;
        messages: ({
            role: "system";
            content: string;
        } | ChatCompletionAssistantMessageParam | ChatCompletionUserMessageParam)[];
        tools: ChatCompletionTool[] | undefined;
        tool_choice: ChatCompletionToolChoiceOption;
    };
    private static systemMessages;
    private static tools;
    private static toolChoice;
    private static mapTool;
    private static mapMessage;
    private static mapMessageContent;
}

export { type CompleteOpenAICompletion, OpenAIUtils };
